// ------------------------------------------------------------------------------------------------
// Author: Bobby Handzhiev
// For: SharkInvestor.com
// ------------------------------------------------------------------------------------------------

var InvestCalc = new Object();
var inv=InvestCalc;

inv.open = function()
{
	window.open("chrome://investcalc/content/calculator.xul","invcalc","chrome,width=430,height=290");
}

inv.numberFormat = function(number, decimals, dec_point, thousands_sep)
{
	// http://kevin.vanzonneveld.net
    // +   original by: Jonas Raoni Soares Silva (http://www.jsfromhell.com)
    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +     bugfix by: Michael White (http://getsprink.com)
    // +     bugfix by: Benjamin Lupton
    // +     bugfix by: Allan Jensen (http://www.winternet.no)
    // +    revised by: Jonas Raoni Soares Silva (http://www.jsfromhell.com)
    // +     bugfix by: Howard Yeend
    // *     example 1: number_format(1234.5678, 2, '.', '');
    // *     returns 1: 1234.57     
 
    var n = number, c = isNaN(decimals = Math.abs(decimals)) ? 2 : decimals;
    var d = dec_point == undefined ? "." : dec_point;
    var t = thousands_sep == undefined ? "," : thousands_sep, s = n < 0 ? "-" : "";
    var i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + "", j = (j = i.length) > 3 ? j % 3 : 0;
    
    return s + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : "")
}


inv.calculate = function()
{
	var invested_amount=parseInt(document.getElementById('invested_amount').value);
	var contribution=parseInt(document.getElementById('contribution').value);
	var ROI=parseInt(document.getElementById('ROI').value);
	var period=parseInt(document.getElementById('period').value);
	var cp=parseInt(document.getElementById('cp').value);
	
	if(isNaN(invested_amount))
	{
		alert("Please enter investment amount");
		document.getElementById('invested_amount').focus();
		return false;
	}
	
	if(isNaN(ROI))
	{
		alert("Please enter expected return on investment");
		document.getElementById('ROI').focus();
		return false;
	}
	
	if(isNaN(period))
	{
		alert("Please select number of years or months");
		document.getElementById('period').focus();
		return false;
	}
	
	if(isNaN(contribution)) contribution=0;
	
	var pROI=parseFloat(ROI/100);	
	var pCP=parseFloat(document.getElementById('cp').value/100);
	
	var compCalc='<listbox id="resultTable" rows="10" style="width:420px;"><listhead>'+
      '<listheader width="80" label="Period" />'+
      '<listheader width="85" label="Principal" />'+
      '<listheader width="85" label="Withdrawn" />'+
      '<listheader width="85" label="Total Withdrawn" />'+
      '<listheader width="85" label="Total ROI" />'+
      '</listhead>'+
      '<listcols><listcol /><listcol /><listcol />'+
      '<listcol /><listcol /></listcols>';
      
    
    var new_principal=0;
    var total_withdrawn=0;
    
    var maxI=parseInt(period)+1;    
    
    for(i = 1 ; i < maxI ; i++ )
    {
	    if(new_principal==0) new_principal=invested_amount;
	    
		new_principal=Math.round(new_principal,2);
										
		profit = new_principal * pROI;						
		profit=Math.round(profit,2);		
				
		addition = profit * pCP;		
		
		withdraw=Math.round((profit-addition),2);
		
				
		//total withdrawn
		total_withdrawn+=withdraw;
				
		//total ROI
		if(invested_amount>0)
		{
			total_roi=(total_withdrawn/invested_amount)*100;
			total_roi=Math.round(total_roi);
		}
		else total_roi=0;
		
		compCalc+='<listitem><listcell width="80" label="'+i+'" />'+    
		'<listcell width="80" label="'+this.numberFormat(new_principal,0,"",",")+'" />'+    
		'<listcell width="80" label="'+this.numberFormat(withdraw,0,"",",")+'" />'+    
		'<listcell width="85" label="'+this.numberFormat(total_withdrawn,0,"",",")+'" />'+    
		'<listcell width="85" label="'+this.numberFormat(total_roi,0,"",",")+'%" />'+    
  		'</listitem>';
  		
  		new_principal=new_principal+addition;
			
		//now add annual addition to this
		new_principal+=contribution;
    }
    
   compCalc+='</listbox>';       
    	
    window.resizeTo(430,505);
	document.getElementById('resultArea').style.display='block';	
	document.getElementById('resultArea').innerHTML=compCalc;

}